---
title: Inspecting web sockets
slug: Tools/Network_Monitor/Inspecting_web_sockets
tags:
  - JavaScript
  - Network Monitor
  - WebAPIs
  - web socket inspector
  - web sockets
---
<p>{{ToolsSidebar}}</p>

<p>Since Firefox 71, the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> has had the ability to inspect <a href="/en-US/docs/Web/API/WebSockets_API">web socket</a> connections. This article explores what functionality the Web Socket Inspector makes available.</p>

<h2 id="Accessing_the_inspector">Accessing the inspector</h2>

<p>When you are inspecting a web app that utilizes a web socket connection, the web socket requests are listed in the list of requests in the Network Monitor along with all other requests.</p>

<p><img alt="WS filter in the network inspector" src="https://mdn.mozillademos.org/files/16991/wsi-filiter.png" style="height: 270px; width: 936px;"></p>

<p>You can use the WS button to filter the list for just web socket connections. Only requests with the <a href="/en-US/docs/Web/HTTP/Status/101">101 status code</a> (WebSocket Protocol Handshake) are visible, which indicates that the server is switching to a web socket connection.</p>

<p>Clicking on a web socket request opens the usual sidebar to reveal additional details. Choose the <strong>Reponse</strong> tab to inspect web socket frames sent and received through the selected connection.</p>

<p><img alt="Messages panel in the web socket inspector" src="https://mdn.mozillademos.org/files/17405/new-web-sockets.png" style="border-style: solid; border-width: 1px; height: 670px; width: 1820px;"></p>

<p>The live-updated table shows data for sent (green arrow) and received (red arrow) frames. Each frame expands on click, so you can inspect the formatted data.</p>

<h2 id="Pausing_web_socket_traffic">Pausing web socket traffic</h2>

<p>You can use the pause/resume button in the Network Monitor toolbar to stop intercepting web socket traffic. This allows you to capture only the frames that you are interested in.</p>

<p><img alt="Pausing the web socket inspector" src="https://mdn.mozillademos.org/files/16989/ws-pause.png" style="height: 88px; width: 936px;"></p>

<h2 id="Filtering_web_socket_frames">Filtering web socket frames</h2>

<p>To focus on specific messages, frames can be filtered using the filter at the top of the <em>Response</em> panel.</p>

<p><img alt="web socket frame filter" src="https://mdn.mozillademos.org/files/17319/WS_response_text_filter.png" style="border-style: solid; border-width: 1px; height: 145px; width: 889px;"></p>

<p>There are also predefined filters, available in the tool bar of the Response pane, grouped into a selection list.</p>

<p><img alt="Screenshot showing the filter menu for WebSocket messages" src="https://mdn.mozillademos.org/files/17216/ws_filter_menu.png" style="height: 244px; width: 437px;"></p>

<p>The following filters are available:</p>

<dl>
 <dt>All</dt>
 <dd>Displays all messages (by default, except control messages).</dd>
 <dt>Sent</dt>
 <dd>Displays only messages sent by the browser (by default, except control messages).</dd>
 <dt>Received</dt>
 <dd>Displays only messages received from the server (by default, except control messages).</dd>
 <dt>Control</dt>
 <dd>(Available starting in Firefox 76). Displays messages for control frames (<code>Ping</code>, <code>Pong</code>, or <code>Close</code>). This filter can be combined with the others, to display, for example, only messages for control frames sent by the browser.</dd>
</dl>

<h2 id="Columns_in_the_Response_pane">Columns in the Response pane</h2>

<p>In the <strong>Response</strong> pane, you can choose to show the following information about each frame:</p>

<ul>
 <li>Data</li>
 <li>Size</li>
 <li>Time</li>
 <li>OpCode</li>
 <li>MaskBit</li>
 <li>FinBit</li>
</ul>

<p>The <em>Data</em> and <em>Time</em> columns are visible by default, but you can customize the interface to see more columns by choosing which ones to show from the context menu that is opened by right-clicking in the table header.</p>

<p><img alt="columns in the messages panel" src="https://mdn.mozillademos.org/files/17320/WS_message_columns.png" style="border-style: solid; border-width: 1px; display: block; height: 224px; margin: 0px auto; width: 456px;"></p>

<h2 id="Expanding_each_message">Expanding each message</h2>

<p>Selecting a message in the list shows a preview of the data being sent in that message, at the bottom of the Response pane.</p>

<p><img alt="web socket payload preview" src="https://mdn.mozillademos.org/files/17321/WS_expand_message.png" style="display: block; height: 265px; margin: 0px auto; width: 520px;"></p>

<h3 id="Supported_WS_protocols">Supported WS protocols</h3>

<p>The inspector currently supports the following web socket protocols:</p>

<ul>
 <li>Plain JSON</li>
 <li>Socket.IO</li>
 <li>SockJS</li>
 <li>SignalR</li>
 <li>WAMP</li>
 <li>STOMP</li>
 <li>STOMP inside SockJS</li>
</ul>

<p>The payload based on those protocols is parsed and displayed as an expandable tree for easy inspection, although you can of course still see the raw data (as sent over the wire) as well.</p>
